/*
 * UCB-BF707 N25Q128A13pDPIAhCo
 *
 * Copyright(C) 2016 Kaneko System Co., Ltd Xerox
 *
 * Version : 0.0.1
 *
 * [History]
 *          Date       Author                     Version     Description
 * ---------------------------------------------------------------------------
 * CREATE : 01/Aug/2016 Shinya Kaneko             v.0.0.1     First release
 *
 * [Note]
 *
 */
#include <sys/platform.h>
#include "common/flash.h"

const char dpia_board_title[] = "UCB-BF707";
extern struct flash_info n25q128a_info;

/******************************************
 * Board settings
 *****************************************/
#define BFIN_MCLKIN_HZ          (25000000)

/******************************************
 * CGU0 settings
 *****************************************/
#define CONFIG_PLL_MULT         (32)
#define CONFIG_PLL_CLKIN_HALF   (0)
#define CONFIG_PLL_CCLK_DIV     (2)
#define CONFIG_PLL_SCLK_DIV     (4)
#define CONFIG_PLL_SCLK0_DIV    (2)
#define CONFIG_PLL_SCLK1_DIV    (1)
#define CONFIG_PLL_DCLK_DIV     (4)
#define CONFIG_PLL_OCLK_DIV     (32)
#define CONFIG_DCLK_HZ          ((BFIN_MCLKIN_HZ << CONFIG_PLL_CLKIN_HALF) * CONFIG_PLL_MULT / CONFIG_PLL_DCLK_DIV)  /* DCLK Frequency */

#define REG_CGU0_DIV_VAL \
    ((CONFIG_PLL_CCLK_DIV  << BITP_CGU_DIV_CSEL)   | \
     (CONFIG_PLL_SCLK0_DIV << BITP_CGU_DIV_S0SEL)  | \
     (CONFIG_PLL_SCLK_DIV  << BITP_CGU_DIV_SYSSEL) | \
     (CONFIG_PLL_SCLK1_DIV << BITP_CGU_DIV_S1SEL)  | \
     (CONFIG_PLL_DCLK_DIV  << BITP_CGU_DIV_DSEL)   | \
     (CONFIG_PLL_OCLK_DIV  << BITP_CGU_DIV_OSEL))

#define REG_CGU0_CTL_VAL \
    ((CONFIG_PLL_MULT << BITP_CGU_CTL_MSEL) | (CONFIG_PLL_CLKIN_HALF << BITP_CGU_CTL_DF))

static void bf70x_cgu0_pll_init(void)
{
    *pREG_CGU0_CCBF_DIS = 0x00000000U;
    if((*pREG_CGU0_CTL & (BITM_CGU_CTL_MSEL | BITM_CGU_CTL_DF)) != REG_CGU0_CTL_VAL)
    {
        *pREG_CGU0_DIV = REG_CGU0_DIV_VAL;
        *pREG_CGU0_CTL = REG_CGU0_CTL_VAL;
        while ((*pREG_CGU0_STAT & (BITM_CGU_STAT_CLKSALGN | BITM_CGU_STAT_PLLBP)) ||
              !(*pREG_CGU0_STAT & BITM_CGU_STAT_PLOCK))
        {
            continue;
        }
    }

    *pREG_CGU0_DIV = REG_CGU0_DIV_VAL | BITM_CGU_DIV_UPDT;
    while(*pREG_CGU0_STAT & BITM_CGU_STAT_CLKSALGN)
        continue;

#if 0
    if((*pREG_DMC0_STAT & BITM_DMC_STAT_INITDONE) != 0u)
    {
        *pREG_DMC0_CTL &= ~BITP_DMC_CTL_SRREQ;
        ssync();
        while((*pREG_DMC0_STAT & BITM_DMC_STAT_SRACK) != 0u)
            continue;
    }
#endif
}

void dpia_init(void)
{
    int32_t l_lc;

//    *pREG_RCU0_CTL = BITM_RCU_CTL_RSTOUTASRT;

    *pREG_L1IM_ICTL = 0U;
    *pREG_L1DM_DCTL = 0U;
    bf70x_cgu0_pll_init();

    for(l_lc = 0; l_lc < 1000000; l_lc++) { ssync(); }
    *pREG_RCU0_CTL = BITM_RCU_CTL_RSTOUTDSRT;

    flash_info = &n25q128a_info;

    *pREG_DMA8_CFG = 0U;
    *pREG_DMA9_CFG = 0U;
}
